- Main Page
- Related Pages
- Data Structures
- Files
- Examples

Functions
Video

## Functions
EOAPI void | elm_obj_video_audio_level_set (double volume)
| Set the audio level of an Elm_Video object. More...
EOAPI double | elm_obj_video_audio_level_get (void)
| Get the audio level of the current video. More...
EOAPI void | elm_obj_video_remember_position_set (Eina_Bool remember)
| Set whether the object can remember the last played position. More...
EOAPI Eina_Bool | elm_obj_video_remember_position_get (void)
| Set whether the object can remember the last played position. More...
EOAPI void | elm_obj_video_play_position_set (double position)
| Set the current position (in seconds) to be played in the Elm_Video object. More...
EOAPI double | elm_obj_video_play_position_get (void)
| Get the current position (in seconds) being played in the Elm_Video object. More...
EOAPI void | elm_obj_video_audio_mute_set (Eina_Bool mute)
| Change the mute state of the Elm_Video object. More...
EOAPI Eina_Bool | elm_obj_video_audio_mute_get (void)
| Is the audio muted. More...
EOAPI Eina_Bool | elm_obj_video_file_set (const char *filename)
| Define the file or URI that will be the video source. More...
EOAPI Eina_Bool | elm_obj_video_is_playing_get (void)
| Is the video actually playing. More...
EOAPI double | elm_obj_video_play_length_get (void)
| Get the total playing time (in seconds) of the Elm_Video object. More...
EOAPI Evas_Object * | elm_obj_video_emotion_get (void)
| Get the underlying Emotion object. More...
EOAPI Eina_Bool | elm_obj_video_is_seekable_get (void)
| Is it possible to seek inside the video. More...
EOAPI const char * | elm_obj_video_title_get (void)
| Get the title (for instance DVD title) from this emotion object. More...
EOAPI void | elm_obj_video_play (void)
| Start to play the video. More...
EOAPI void | elm_obj_video_pause (void)
| Pause the video. More...
EOAPI void | elm_obj_video_stop (void)
| Stop the video. More...
void | elm_video::play () const
| Start to play the video. More...
void | elm_video::pause () const
| Pause the video. More...
void | elm_video::stop () const
| Stop the video. More...
void | elm_video_audio_level_set (Eo *obj, double volume)
| Set the audio level of an Elm_Video object. More...
double | elm_video_audio_level_get (const Eo *obj)
| Get the audio level of the current video. More...
void | elm_video_remember_position_set (Eo *obj, Eina_Bool remember)
| Set whether the object can remember the last played position. More...
Eina_Bool | elm_video_remember_position_get (const Eo *obj)
| Set whether the object can remember the last played position. More...
void | elm_video_play_position_set (Eo *obj, double position)
| Set the current position (in seconds) to be played in the Elm_Video object. More...
double | elm_video_play_position_get (const Eo *obj)
| Get the current position (in seconds) being played in the Elm_Video object. More...
void | elm_video_audio_mute_set (Eo *obj, Eina_Bool mute)
| Change the mute state of the Elm_Video object. More...
Eina_Bool | elm_video_audio_mute_get (const Eo *obj)
| Is the audio muted. More...
Eina_Bool | elm_video_file_set (Eo *obj, const char *filename)
| Define the file or URI that will be the video source. More...
Eina_Bool | elm_video_is_playing_get (const Eo *obj)
| Is the video actually playing. More...
double | elm_video_play_length_get (const Eo *obj)
| Get the total playing time (in seconds) of the Elm_Video object. More...
Evas_Object * | elm_video_emotion_get (const Eo *obj)
| Get the underlying Emotion object. More...
Eina_Bool | elm_video_is_seekable_get (const Eo *obj)
| Is it possible to seek inside the video. More...
const char * | elm_video_title_get (const Eo *obj)
| Get the title (for instance DVD title) from this emotion object. More...
void | elm_video_play (Eo *obj)
| Start to play the video. More...
void | elm_video_pause (Eo *obj)
| Pause the video. More...
void | elm_video_stop (Eo *obj)
| Stop the video. More...
Evas_Object * | elm_player_add (Evas_Object *parent)
| Add a new Elm_Player object to the given parent Elementary (container) object. More...
Evas_Object * | elm_video_add (Evas_Object *parent)
| Add a new Elm_Video object to the given parent Elementary (container) object. More...

## Detailed Description

Elementary comes with two object that help design application that need to display video.

The first one, Elm_Video, display a video by using Emotion. It embeds the video inside an Edje object, so you can do some animation depending on the video state change. It also implements a resource management policy to remove this burden from the application.

The second one, Elm_Player is a video player that need to be linked with an Elm_Video. It take care of updating its content according to Emotion event and provide a way to theme itself. It also automatically raises the priority of the linked Elm_Video so it will use the video decoder, if available. It also activates the "remember" function on the linked Elm_Video object.

Both widgets inherit from the Layout one, so that all the functions acting on it also work for video objects.

This widget emits the following signals, besides the ones sent from Layout:

- `"focused"` : When the video has received focus. (since 1.8)
- `"unfocused"` : When the video has lost focus. (since 1.8)

The player widget emits the following signals, besides the ones sent from Layout:

- `"forward,clicked"` - the user clicked the forward button.
- `"info,clicked"` - the user clicked the info button.
- `"next,clicked"` - the user clicked the next button.
- `"pause,clicked"` - the user clicked the pause button.
- `"play,clicked"` - the user clicked the play button.
- `"prev,clicked"` - the user clicked the prev button.
- `"rewind,clicked"` - the user clicked the rewind button.
- `"stop,clicked"` - the user clicked the stop button.

Default content parts of the player widget that you can use for are:

- "video" - A video of the player

## Function Documentation

EOAPI double elm_obj_video_audio_level_get | ( | void |  | ) |

Get the audio level of the current video.

Returns
  the current audio level.

Referenced by elm_video_audio_level_get().

EOAPI void elm_obj_video_audio_level_set | ( | double | volume | ) |

Set the audio level of an Elm_Video object.

Parameters

  [in] | volume | The new audio volume.

Referenced by elm_video_audio_level_set().

EOAPI Eina_Bool elm_obj_video_audio_mute_get | ( | void |  | ) |

Is the audio muted.

Returns
  `EINA_TRUE` if the audio is muted.

Referenced by elm_video_audio_mute_get().

EOAPI void elm_obj_video_audio_mute_set | ( | Eina_Bool | mute | ) |

Change the mute state of the Elm_Video object.

Parameters

  [in] | mute | The new mute state.

Referenced by elm_video_audio_mute_set().

EOAPI Evas_Object* elm_obj_video_emotion_get | ( | void |  | ) |

Get the underlying Emotion object.

Returns
  the underlying Emotion object.

Referenced by elm_video_emotion_get().

EOAPI Eina_Bool elm_obj_video_file_set | ( | const char * | filename | ) |

Define the file or URI that will be the video source.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

This function will explicitly define a file or URI as a source for the video of the Elm_Video object.

See also
  elm_video_add()
  elm_player_add()

Parameters

  [in] | filename | The file or URI to target. Local files can be specified using file:// or by using full file paths. URI could be remote source of video, like http:// or local source like WebCam (v4l2://). (You can use Emotion API to request and list the available Webcam on your system).

Referenced by elm_video_file_set().

EOAPI Eina_Bool elm_obj_video_is_playing_get | ( | void |  | ) |

Is the video actually playing.

Returns
  `EINA_TRUE` if the video is actually playing.

You should consider watching event on the object instead of polling the object state.

Referenced by elm_video_is_playing_get().

EOAPI Eina_Bool elm_obj_video_is_seekable_get | ( | void |  | ) |

Is it possible to seek inside the video.

Returns
  `EINA_TRUE` if is possible to seek inside the video.

Referenced by elm_video_is_seekable_get().

EOAPI void elm_obj_video_pause | ( | void |  | ) |

Pause the video.

Pause the video and start a timer to trigger suspend mode.

Referenced by elm_video_pause(), and elm_video::pause().

EOAPI void elm_obj_video_play | ( | void |  | ) |

Start to play the video.

Start to play the video and cancel all suspend state.

Referenced by elm_video_play(), and elm_video::play().

EOAPI double elm_obj_video_play_length_get | ( | void |  | ) |

Get the total playing time (in seconds) of the Elm_Video object.

Returns
  The total duration (in seconds) of the media file.

Referenced by elm_video_play_length_get().

EOAPI double elm_obj_video_play_position_get | ( | void |  | ) |

Get the current position (in seconds) being played in the Elm_Video object.

Returns
  The time (in seconds) since the beginning of the media file.

Referenced by elm_video_play_position_get().

EOAPI void elm_obj_video_play_position_set | ( | double | position | ) |

Set the current position (in seconds) to be played in the Elm_Video object.

Parameters

  [in] | position | The time (in seconds) since the beginning of the media file.

Referenced by elm_video_play_position_set().

EOAPI Eina_Bool elm_obj_video_remember_position_get | ( | void |  | ) |

Set whether the object can remember the last played position.

Returns
  whether the object remembers the last played position (`EINA_TRUE`) or not.

Note
  This API only serves as indication. System support is required.

Referenced by elm_video_remember_position_get().

EOAPI void elm_obj_video_remember_position_set | ( | Eina_Bool | remember | ) |

Set whether the object can remember the last played position.

Note
  This API only serves as indication. System support is required.

Parameters

  [in] | remember | the last played position of the Elm_Video object.

Referenced by elm_video_remember_position_set().

EOAPI void elm_obj_video_stop | ( | void |  | ) |

Stop the video.

Stop the video and put the emotion in deep sleep mode.

Referenced by elm_video_stop(), and elm_video::stop().

EOAPI const char* elm_obj_video_title_get | ( | void |  | ) |

Get the title (for instance DVD title) from this emotion object.

Returns
  A string containing the title.

This function is only useful when playing a DVD.

Note
  Don't change or free the string returned by this function.

Referenced by elm_video_title_get().

Evas_Object* elm_player_add | ( | Evas_Object * | parent | ) |

Add a new Elm_Player object to the given parent Elementary (container) object.

Parameters

  parent | The parent object

Returns
  a new player widget handle or `NULL`, on errors.

This function inserts a new player widget on the canvas.

See also
  elm_object_part_content_set()

Evas_Object* elm_video_add | ( | Evas_Object * | parent | ) |

Add a new Elm_Video object to the given parent Elementary (container) object.

Parameters

  parent | The parent object

Returns
  a new video widget handle or `NULL`, on errors.

This function inserts a new video widget on the canvas.

See also
  elm_video_file_set()

double elm_video_audio_level_get | ( | const Eo * | obj | ) |

Get the audio level of the current video.

Returns
  the current audio level.

References elm_obj_video_audio_level_get().

void elm_video_audio_level_set | ( | Eo * | obj,
|  | double | volume
| ) |  |

Set the audio level of an Elm_Video object.

Parameters

  [in] | volume | The new audio volume.

References elm_obj_video_audio_level_set().

Eina_Bool elm_video_audio_mute_get | ( | const Eo * | obj | ) |

Is the audio muted.

Returns
  `EINA_TRUE` if the audio is muted.

References elm_obj_video_audio_mute_get().

void elm_video_audio_mute_set | ( | Eo * | obj,
|  | Eina_Bool | mute
| ) |  |

Change the mute state of the Elm_Video object.

Parameters

  [in] | mute | The new mute state.

References elm_obj_video_audio_mute_set().

Evas_Object* elm_video_emotion_get | ( | const Eo * | obj | ) |

Get the underlying Emotion object.

Returns
  the underlying Emotion object.

References elm_obj_video_emotion_get().

Eina_Bool elm_video_file_set | ( | Eo * | obj,
|  | const char * | filename
| ) |  |

Define the file or URI that will be the video source.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

This function will explicitly define a file or URI as a source for the video of the Elm_Video object.

See also
  elm_video_add()
  elm_player_add()

Parameters

  [in] | filename | The file or URI to target. Local files can be specified using file:// or by using full file paths. URI could be remote source of video, like http:// or local source like WebCam (v4l2://). (You can use Emotion API to request and list the available Webcam on your system).

References elm_obj_video_file_set().

Eina_Bool elm_video_is_playing_get | ( | const Eo * | obj | ) |

Is the video actually playing.

Returns
  `EINA_TRUE` if the video is actually playing.

You should consider watching event on the object instead of polling the object state.

References elm_obj_video_is_playing_get().

Eina_Bool elm_video_is_seekable_get | ( | const Eo * | obj | ) |

Is it possible to seek inside the video.

Returns
  `EINA_TRUE` if is possible to seek inside the video.

References elm_obj_video_is_seekable_get().

void elm_video_pause | ( | Eo * | obj | ) |

Pause the video.

Pause the video and start a timer to trigger suspend mode.

References elm_obj_video_pause().

void elm_video_play | ( | Eo * | obj | ) |

Start to play the video.

Start to play the video and cancel all suspend state.

References elm_obj_video_play().

double elm_video_play_length_get | ( | const Eo * | obj | ) |

Get the total playing time (in seconds) of the Elm_Video object.

Returns
  The total duration (in seconds) of the media file.

References elm_obj_video_play_length_get().

double elm_video_play_position_get | ( | const Eo * | obj | ) |

Get the current position (in seconds) being played in the Elm_Video object.

Returns
  The time (in seconds) since the beginning of the media file.

References elm_obj_video_play_position_get().

void elm_video_play_position_set | ( | Eo * | obj,
|  | double | position
| ) |  |

Set the current position (in seconds) to be played in the Elm_Video object.

Parameters

  [in] | position | The time (in seconds) since the beginning of the media file.

References elm_obj_video_play_position_set().

Eina_Bool elm_video_remember_position_get | ( | const Eo * | obj | ) |

Set whether the object can remember the last played position.

Returns
  whether the object remembers the last played position (`EINA_TRUE`) or not.

Note
  This API only serves as indication. System support is required.

References elm_obj_video_remember_position_get().

void elm_video_remember_position_set | ( | Eo * | obj,
|  | Eina_Bool | remember
| ) |  |

Set whether the object can remember the last played position.

Note
  This API only serves as indication. System support is required.

Parameters

  [in] | remember | the last played position of the Elm_Video object.

References elm_obj_video_remember_position_set().

void elm_video_stop | ( | Eo * | obj | ) |

Stop the video.

Stop the video and put the emotion in deep sleep mode.

References elm_obj_video_stop().

const char* elm_video_title_get | ( | const Eo * | obj | ) |

Get the title (for instance DVD title) from this emotion object.

Returns
  A string containing the title.

This function is only useful when playing a DVD.

Note
  Don't change or free the string returned by this function.

References elm_obj_video_title_get().

void elm_video::pause | ( |  | ) | const
| inline

Pause the video.

Pause the video and start a timer to trigger suspend mode.

References elm_obj_video_pause().

void elm_video::play | ( |  | ) | const
| inline

Start to play the video.

Start to play the video and cancel all suspend state.

References elm_obj_video_play().

void elm_video::stop | ( |  | ) | const
| inline

Stop the video.

Stop the video and put the emotion in deep sleep mode.

References elm_obj_video_stop().